hpp-core: Constraints

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Modules | Classes | Functions
Constraints
Collaboration diagram for Constraints:

## Modules
| Tools

## Classes
class | hpp::core::ConfigProjector
class | hpp::core::ConstraintSet
class | hpp::core::Constraint

## Functions
std::ostream & | hpp::constraints::operator<< (std::ostream &os, const DifferentiableFunction &f)
std::ostream & | hpp::core::operator<< (std::ostream &os, const Constraint &constraint)

## Detailed Description

Some robots can be subject to constraints.

- closed kinematic chains,
- quasi-static equilibrium for legged robots

are examples of such constraints. These constraints can be defined implicitely by an equation the left hand side of which is a differentiable function of the robot configuration.

Classes of this module enable users to define such constraints by deriving class Constraint and by storing instances in ConstraintSet.

ConfigProjector defines implicit constraints by equalities and/or inequalities between a differentiable function and a constant vector.

LockedJoint set the position of one joint to a fixed value.

Each ConstraintSet may contain at most one ConfigProjector. LockedJoint instances added to a ConstraintSet are in fact stored by the ConfigProjector of the ConstraintSet if any. The rationale is that the computations that solve numerical constraints are optimized by solving only for non locked degrees of freedom.

Below is a diagram of the classes that implement constraints with the description of some methods to help advanced user to understand how those classes interact between each other.

#### Constraint | #### ConstraintSet
addToSet (set): set.push_back (self) addLockedJoint (lockedDof): pass | addToSet (set): for c in constraints_: c.addToSet (set) addLockedJoint (ld): for c in constraints_: c.addLockedJoint (ld) addConstraint (c): c.addToSet (self)
#### ConfigProjector addToSet (set): if set.configProjector_: throw if set.lockedDof_: throw set.removeConfigProjector () set.configProjector_ = self Constraint::addToSet (set) | #### LockedJoint addToSet (set): set.lockedJoint_ = true set.addLockedJoint (self)

## Function Documentation

## ◆ operator<<()

std::ostream & hpp::core::operator<< | ( | std::ostream & | os,
|  | const Constraint & | constraint
| ) |  |
| inline